﻿create schema tca_dw_admin;


GRANT USAGE ON SCHEMA tca_dw_admin TO tca_dw_admin ;

ALTER DEFAULT PRIVILEGES IN SCHEMA tca_dw_admin GRANT ALL PRIVILEGES ON TABLES TO tca_dw_admin;
ALTER DEFAULT PRIVILEGES IN SCHEMA tca_dw_admin GRANT ALL PRIVILEGES ON SEQUENCES TO tca_dw_admin;

SET search_path TO tca_dw_admin;

create sequence seq_id_entorno start with 1 increment by 1;
create sequence seq_id_terapeuta start with 1 increment by 1;
create sequence seq_id_tipo_evento start with 1 increment by 1;	

CREATE TABLE tca_d_paciente		(id_paciente serial primary key,
					nombre_paciente varchar(255) not null unique,
					ciudad varchar(255),
					sexo varchar(1),
					id_entorno integer,
					nombre_entorno varchar(255),
					id_terapeuta integer,
					nombre_terapeuta varchar(255),
					id_centmed integer,
					nombre_centmed  varchar(255),
					ciudad_centmed  varchar(255)
					);

CREATE TABLE tca_d_tiempo		(id_fecha serial primary key,
					fecha date not null ,
					anio integer,
					trimestre integer,
					mes integer,
					mes_nombre varchar(25),
					semana_anio integer,
					dia_mes integer,
					dia_nombre varchar(25),
					franja_dia varchar(50),
					unique (fecha,franja_dia)
					);


CREATE TABLE tca_d_evento		(id_evento serial primary key,
					nombre_evento varchar(255) not null unique,
					id_tipo_evento integer,
					nombre_tipo_evento varchar(255) not null);	
	

CREATE TABLE tca_h_diario		(id_diario serial primary key,
					id_paciente integer references tca_d_paciente,
					id_fecha integer references tca_d_tiempo,
					id_evento integer references tca_d_evento,
					cantidad_eventos numeric
					);








							