﻿create schema tca_admin;

GRANT USAGE ON SCHEMA tca_admin TO tca_admin ;

ALTER DEFAULT PRIVILEGES IN SCHEMA tca_admin GRANT ALL PRIVILEGES ON TABLES TO tca_admin;
ALTER DEFAULT PRIVILEGES IN SCHEMA tca_admin GRANT ALL PRIVILEGES ON SEQUENCES TO tca_admin;

SET search_path TO tca_admin;



CREATE TABLE tca_centmed	(code integer,
				name varchar(255) not null,
				cp varchar(5),
				city varchar(250));

CREATE TABLE tca_therapist	(name varchar(255) not null,
				centmed integer );

CREATE TABLE tca_patient	(name varchar(255) not null,
				city varchar(250),
				gender varchar(1) ,
				environment varchar(250),
				therapist varchar(250));


CREATE TABLE tca_episode	(patient varchar(250),
				day date,
				hour varchar(250),
				episode varchar(250));
				
CREATE TABLE tca_emotion	(patient varchar(250),
				day date,
				hour varchar(250),
				emotion varchar(250));


CREATE TABLE tca_meal		(patient varchar(250),
				day date,
				hour varchar(250),
				meal varchar(250));

CREATE TABLE tca_activity	(patient varchar(250),
				day date,
				hour varchar(250),
				activity varchar(250));

						