﻿begin;

insert into tca_dw_admin.tca_d_evento(nombre_evento, nombre_tipo_evento)
select distinct activity, 'ACTIVITY'from tca_admin.tca_activity where activity is not null;

insert into tca_dw_admin.tca_d_evento(nombre_evento, nombre_tipo_evento)
select distinct meal, 'MEAL'  from tca_admin.tca_meal where meal is not null;

insert into tca_dw_admin.tca_d_evento(nombre_evento, nombre_tipo_evento)
select distinct emotion, 'EMOTION' from tca_admin.tca_emotion where emotion is not null;

insert into tca_dw_admin.tca_d_evento(nombre_evento, nombre_tipo_evento)
select distinct coalesce(episode,'NO EPISODE'), 'EPISODE'from tca_admin.tca_episode;
-------------------------------------------------------------------
insert into tca_dw_admin.tca_d_tiempo(fecha,franja_dia,anio,mes,dia_mes,trimestre,semana_anio,mes_nombre,dia_nombre)
select distinct day as fecha, hour as franja_dia, extract(year from day) as anio ,extract(month from day) as mes,extract(day from day) as dia_mes ,extract(quarter from day)as trimestre,
extract(week from day) as semana_anio,
case extract(month from day)
when 1 then 'Enero'
when 2 then 'Febrero'
when 3 then 'Marzo'
when 4 then 'Abril'
when 5 then 'Mayo'
when 6 then 'Junio'
when 7 then 'Julio'
when 8 then 'Agosto'
when 9 then 'Septiembre'
when 10 then 'Octubre'
when 11 then 'Noviembre'
else 'Diciembre' end as mes_nombre,

case extract(dow from day)
when 1 then 'Lunes'
when 2 then 'Martes'
when 3 then 'Miercoles'
when 4 then 'Jueves'
when 5 then 'Viernes'
when 6 then 'Sabado'
else 'Domingo' end as dia_nombre
from (	select distinct day, hour from tca_admin.tca_activity where day is not null 
	union
	select distinct day, hour from tca_admin.tca_meal where day is not null
	union
	select distinct day, hour from tca_admin.tca_emotion where day is not null
	union
	select distinct day, hour from tca_admin.tca_episode where day is not null
	order by 1,2 )as Fechas
;

--------------------------------------
insert into tca_dw_admin.tca_d_paciente(nombre_paciente, ciudad, nombre_entorno,sexo, nombre_terapeuta, id_centmed, nombre_centmed, ciudad_centmed)
select pat.name, pat.city, pat.environment, pat.gender, the.name,  cent.code,cent.name, cent.city
from tca_admin.tca_patient pat, tca_admin.tca_therapist the, tca_admin.tca_centmed cent
where pat.therapist = the.name
and the.centmed=cent.code
; 
--------------------------------------


insert into tca_dw_admin.tca_h_diario(id_paciente,id_fecha,id_evento,cantidad_eventos)
select pat.id_paciente, tpo.id_fecha, eve.id_evento,count(1)
from tca_dw_admin.tca_d_paciente pat, tca_dw_admin.tca_d_tiempo tpo, tca_dw_admin.tca_d_evento eve, tca_admin.tca_activity act
where pat.nombre_paciente = act.patient
and   tpo.fecha = act.day
and   tpo.franja_dia = act.hour
and   eve.nombre_evento=act.activity
and   eve.nombre_tipo_evento='ACTIVITY'
group by pat.id_paciente, tpo.id_fecha, eve.id_evento;

insert into tca_dw_admin.tca_h_diario(id_paciente,id_fecha,id_evento,cantidad_eventos)
select pat.id_paciente, tpo.id_fecha, eve.id_evento,count(1)
from tca_dw_admin.tca_d_paciente pat, tca_dw_admin.tca_d_tiempo tpo, tca_dw_admin.tca_d_evento eve, tca_admin.tca_meal meal
where pat.nombre_paciente = meal.patient
and   tpo.fecha = meal.day
and   tpo.franja_dia = meal.hour
and   eve.nombre_evento=meal.meal
and   eve.nombre_tipo_evento='MEAL'
group by pat.id_paciente, pat.id_terapeuta,pat.id_centmed, tpo.id_fecha, eve.id_evento;

insert into tca_dw_admin.tca_h_diario(id_paciente,id_fecha,id_evento,cantidad_eventos)
select pat.id_paciente, tpo.id_fecha, eve.id_evento,count(1)
from tca_dw_admin.tca_d_paciente pat, tca_dw_admin.tca_d_tiempo tpo, tca_dw_admin.tca_d_evento eve, tca_admin.tca_episode epi
where pat.nombre_paciente = epi.patient
and   tpo.fecha = epi.day
and   tpo.franja_dia = epi.hour
and   eve.nombre_evento=coalesce(episode,'NO EPISODE')
and   eve.nombre_tipo_evento='EPISODE'
group by pat.id_paciente, pat.id_terapeuta,pat.id_centmed, tpo.id_fecha, eve.id_evento;

insert into tca_dw_admin.tca_h_diario(id_paciente,id_fecha,id_evento,cantidad_eventos)
select pat.id_paciente, tpo.id_fecha, eve.id_evento,count(1)
from tca_dw_admin.tca_d_paciente pat,tca_dw_admin.tca_d_tiempo tpo, tca_dw_admin.tca_d_evento eve, tca_admin.tca_emotion emo
where pat.nombre_paciente = emo.patient
and   tpo.fecha = emo.day
and   tpo.franja_dia = emo.hour
and   eve.nombre_evento=emo.emotion
and   eve.nombre_tipo_evento='EMOTION'
group by pat.id_paciente, pat.id_terapeuta,pat.id_centmed, tpo.id_fecha, eve.id_evento;

--------------------------------------

commit;

DO $$
DECLARE
    c_terapeutas CURSOR FOR 	select  p1.nombre_terapeuta , coalesce (min(p1.id_terapeuta), nextval('tca_dw_admin.seq_id_terapeuta')) id_terapeuta
				FROM tca_dw_admin.tca_d_paciente p1,tca_dw_admin.tca_d_paciente p2
				where p1.nombre_terapeuta = p2.nombre_terapeuta
				group by p1.nombre_terapeuta; 

    c_entornos CURSOR FOR 	select  p1.nombre_entorno , coalesce (min(p1.id_entorno), nextval('tca_dw_admin.seq_id_entorno')) id_entorno
				FROM tca_dw_admin.tca_d_paciente p1,tca_dw_admin.tca_d_paciente p2
				where p1.nombre_entorno = p2.nombre_entorno
				group by p1.nombre_entorno; 	
					
    c_tipos_eventos CURSOR FOR 	select  e1.nombre_tipo_evento , coalesce (min(e1.id_tipo_evento), nextval('tca_dw_admin.seq_id_tipo_evento')) id_tipo_evento
				FROM tca_dw_admin.tca_d_evento e1,tca_dw_admin.tca_d_evento e2
				where e1.nombre_tipo_evento = e2.nombre_tipo_evento
				group by e1.nombre_tipo_evento; 						

BEGIN
    FOR terapeutas_record IN C_terapeutas LOOP
        
	update tca_dw_admin.tca_d_paciente 
	set id_terapeuta = terapeutas_record.id_terapeuta
	where id_terapeuta is null
	and nombre_terapeuta=terapeutas_record.nombre_terapeuta;
    END LOOP;
    FOR entornos_record IN C_entornos LOOP
        
	update tca_dw_admin.tca_d_paciente 
	set id_entorno = entornos_record.id_entorno
	where id_entorno is null
	and nombre_entorno=entornos_record.nombre_entorno;
        
    END LOOP;
    FOR tipos_eventos_record IN C_tipos_eventos LOOP
        
	update tca_dw_admin.tca_d_evento 
	set id_tipo_evento = tipos_eventos_record.id_tipo_evento
	where id_tipo_evento is null
	and nombre_tipo_evento=tipos_eventos_record.nombre_tipo_evento;
        
    END LOOP;
END$$;